
#include "stdafx.h"

#include <winioctl.h>
#include "sdk_can.h"

int _tmain(int argc, TCHAR *argv[], TCHAR *envp[])
{

	IOCTL_CAN_COMMAND_IN cmdIn;
	IOCTL_CAN_CONFIG_IN cfgIn;
	IOCTL_CAN_SEND_IN sendIn;
	CAN_MESSAGE msgArray[1];


	// Open the CAN driver
	HANDLE hCan = CreateFile(L"CAN1:",0,0,NULL,OPEN_EXISTING,0,NULL);
	if (hCan == NULL)
	{
		goto error;
	}

	// Make sure the controller is stopped
	cmdIn = STOP;
	if(!DeviceIoControl(hCan,IOCTL_CAN_COMMAND,&cmdIn,sizeof(cmdIn),NULL,0,NULL,NULL))
	{
		goto error;
	}

	// Reset the controller
	cmdIn = RESET;
	if(!DeviceIoControl(hCan,IOCTL_CAN_COMMAND,&cmdIn,sizeof(cmdIn),NULL,0,NULL,NULL))
	{
		goto error;
	}

	// Configure the controller
	cfgIn.cfgType = BAUDRATE_CFG;
	cfgIn.BaudRate = 250000;
	if(!DeviceIoControl(hCan,IOCTL_CAN_CONFIG,&cfgIn,sizeof(cfgIn),NULL,0,NULL,NULL))
	{
		goto error;
	}

	// Start the controller
	cmdIn = START;
	if(!DeviceIoControl(hCan,IOCTL_CAN_COMMAND,&cmdIn,sizeof(cmdIn),NULL,0,NULL,NULL))
	{
		goto error;
	}
	// Create a new message to send
	msgArray[0].id.u32 =0;
	msgArray[0].id.s_extended.id = 0x8721;
	msgArray[0].id.s_extended.extended = 0x1;
	msgArray[0].length = 1;
	msgArray[0].MDH = 0xAA;
	msgArray[0].MDL = 0x55;
	sendIn.priority = TXMEDIUM;
	sendIn.timeout = 1000;
	sendIn.nbMsg = 1;
	sendIn.msgArray = msgArray;

	// Send the message over the bus
	if(!DeviceIoControl(hCan,IOCTL_CAN_SEND,&sendIn,sizeof(sendIn),NULL,0,NULL,NULL))
	{
		goto error;
	}

	// Stop the controller
	cmdIn = STOP;
	if(!DeviceIoControl(hCan,IOCTL_CAN_COMMAND,&cmdIn,sizeof(cmdIn),NULL,0,NULL,NULL))
	{
		goto error;
	}

error:

	if (hCan != NULL)
	{
		// Close the CAN driver
		CloseHandle(hCan);
	}


	return 0;
}
